Const adSaveCreateNotExist = 1
Const adSaveCreateOverWrite = 2
Const adTypeBinary = 1 'Binary data
Const adTypeText = 2 '(Default) Text data
Const adLF = 10
Const adCR = 13
Const adCRLF = -1

Const adReadLine = -2
Const adWriteChar = 0
Const adWriteLine = 1

Const SD_STAT = 0
Const SD_LSTART = 1
Const SD_LEND = 2
Const SD_TYPE = 3
Const SD_DECIMALS = 4
Const SD_P1 = 5
Const SD_P2 = 6
Const SD_P3 = 7
Const SD_P4 = 8
Const SD_P5 = 9
Const SD_P6 = 10
Const SDFLDCNT = 11

Const SDFLDSEP = ","
Const SDSTRQUOT = """"

Const InFile = "statdata.csv"
Const OutFile = "CalcStat.lua"

Main
Sub Main

	Dim SDInfoLst

	ReadSDFile InFile,SDInfoLst
	
	If Not IsEmpty(SDInfoLst) Then
		MsgBox Replace("Red #N# data lines","#N#",CStr(UBound(SDInfoLst)+1))
	End If

	Dim OutStream
	Set OutStream = CreateObject("ADODB.Stream")
	With OutStream
		.Type = adTypeText
		.CharSet = "us-ascii"
		.LineSeparator = adCRLF
		.Open

'		For SI = LBound(SDInfoLst) To UBound(SDInfoLst)
'			.WriteText SDInfoLst(SI)(SD_STAT), adWriteLine
'		Next

		WriteScrStart OutStream

		WriteScrHSNs OutStream,SDInfoLst

		WriteScrEnd OutStream

		.SaveToFile OutFile, adSaveCreateOverWrite
		.Close
	End With
	Set OutStream = Nothing

End Sub

Sub WriteScrStart(theOutStream)

	With theOutStream

.WriteText "import (string.gsub(getfenv(1)._.Name,""%.CalcStat"","""").."".CalcSsup"");", adWriteLine
.WriteText "", adWriteLine
.WriteText "function CalcStat(sname, slvl, sparam)", adWriteLine
.WriteText "", adWriteLine
.WriteText "	local sn = string.upper(string.match(sname,""(%a+)""));", adWriteLine
.WriteText "	local hsn = string.sub(sn,1,1);", adWriteLine
.WriteText "", adWriteLine
.WriteText "	local L = slvl;", adWriteLine
.WriteText "	local N = 1;", adWriteLine
.WriteText "	local C = """";", adWriteLine
.WriteText "", adWriteLine
.WriteText "	if sparam ~= nil then", adWriteLine
.WriteText "		if type(sparam) == ""number"" then", adWriteLine
.WriteText "			N = sparam;", adWriteLine
.WriteText "		else", adWriteLine
.WriteText "			C = sparam;", adWriteLine
.WriteText "		end", adWriteLine
.WriteText "	end", adWriteLine
.WriteText "", adWriteLine

	End With

End Sub

Sub WriteScrEnd(theOutStream)

	With theOutStream

.WriteText "", adWriteLine
.WriteText "end", adWriteLine

	End With

End Sub

Sub WriteScrStat(theOutStream,theStat,theSDInfoLst)

	With theOutStream

		Dim StatPos
		StatPos = -1
		
		For SI = LBound(theSDInfoLst) To UBound(theSDInfoLst)
			If theSDInfoLst(SI)(SD_STAT) = theStat Then
				StatPos = SI
				Exit For
			End If
		Next

		If StatPos >= 0 Then
			Dim Build

			For SI = StatPos To UBound(theSDInfoLst)
				If theSDInfoLst(SI)(SD_STAT) <> theStat Then
					Exit For
				End If
				If theSDInfoLst(SI)(SD_LEND) <> "" And SI = StatPos Then
.WriteText "			if L-DblCalcDev <= "+theSDInfoLst(SI)(SD_LEND)+" then", adWriteLine
				ElseIf theSDInfoLst(SI)(SD_LEND) <> "" Then
.WriteText "			elseif L-DblCalcDev <= "+theSDInfoLst(SI)(SD_LEND)+" then", adWriteLine
				ElseIf theSDInfoLst(SI)(SD_LSTART) <> "" Then
.WriteText "			else", adWriteLine
				End If

				Build = ""

				If theSDInfoLst(SI)(SD_TYPE) = "A" Then
					Build = Build+theSDInfoLst(SI)(SD_P1)
				ElseIf theSDInfoLst(SI)(SD_TYPE) = "C" Then
					If InStr(theSDInfoLst(SI)(SD_P1),"/") Or InStr(theSDInfoLst(SI)(SD_P1),"+")  Or InStr(theSDInfoLst(SI)(SD_P1),"-") Then
						Build = Build+"("+theSDInfoLst(SI)(SD_P1)+")*N"
					ElseIf theSDInfoLst(SI)(SD_P1) = "1" Then
						Build = Build+"N"
					Else
						Build = Build+theSDInfoLst(SI)(SD_P1)+"*N"
					End If
				ElseIf theSDInfoLst(SI)(SD_TYPE) = "F" Then
					Build = Build+theSDInfoLst(SI)(SD_P1)+"("
					If theSDInfoLst(SI)(SD_P2) <> "" Then
						Build = Build+theSDInfoLst(SI)(SD_P2)
					If theSDInfoLst(SI)(SD_P3) <> "" Then
						Build = Build+","+theSDInfoLst(SI)(SD_P3)
					If theSDInfoLst(SI)(SD_P4) <> "" Then
						Build = Build+","+theSDInfoLst(SI)(SD_P4)
					If theSDInfoLst(SI)(SD_P5) <> "" Then
						Build = Build+","+theSDInfoLst(SI)(SD_P5)
					If theSDInfoLst(SI)(SD_P6) <> "" Then
						Build = Build+","+theSDInfoLst(SI)(SD_P6)
					End If
					End If
					End If
					End If
					End If
					Build = Build+")*N"
				ElseIf theSDInfoLst(SI)(SD_TYPE) = "E" Then
					If theSDInfoLst(SI)(SD_LSTART) <> "" Then
						Build = Build+"ExpFmod("+theSDInfoLst(SI)(SD_P1)+","+theSDInfoLst(SI)(SD_LSTART)+","
					Else
						Build = Build+"ExpFmod("+theSDInfoLst(SI)(SD_P1)+",1,"
					End If
					Build = Build+theSDInfoLst(SI)(SD_P2)+","
					IF theSDInfoLst(SI)(SD_P3) <> "" Then
						Build = Build+"L+"+theSDInfoLst(SI)(SD_P3)+")*N"
					Else
						Build = Build+"L)*N"
					End If
				ElseIf theSDInfoLst(SI)(SD_TYPE) = "L" Then
					If InStr(theSDInfoLst(SI)(SD_P1),"/") Or InStr(theSDInfoLst(SI)(SD_P1),"+")  Or InStr(theSDInfoLst(SI)(SD_P1),"-") Then
						Build = Build+"("+theSDInfoLst(SI)(SD_P1)+")*L"
					ElseIf theSDInfoLst(SI)(SD_P1) = "1" Then
						Build = Build+"L"
					Else
						Build = Build+theSDInfoLst(SI)(SD_P1)+"*L"
					End If
					If theSDInfoLst(SI)(SD_P2) <> "" Then
						Build = "("+Build+"+"+theSDInfoLst(SI)(SD_P2)+")*N"
					Else
						Build = Build+"*N"
					End If
				ElseIf theSDInfoLst(SI)(SD_TYPE) = "N" Then
					If theSDInfoLst(SI)(SD_LSTART) <> "" And theSDInfoLst(SI)(SD_LSTART) <> "1" Then
						Build = Build+"NamedRangeValue("""+theSDInfoLst(SI)(SD_P1)+""",L-"+CStr(theSDInfoLst(SI)(SD_LSTART)-1)+","+theSDInfoLst(SI)(SD_P2)+")*N"
					Else
						Build = Build+"NamedRangeValue("""+theSDInfoLst(SI)(SD_P1)+""",L,"+theSDInfoLst(SI)(SD_P2)+")*N"
					End If
				ElseIf theSDInfoLst(SI)(SD_TYPE) = "P" Then
					Build = Build+"CalcPercAB("+theSDInfoLst(SI)(SD_P1)+","+theSDInfoLst(SI)(SD_P2)+","+theSDInfoLst(SI)(SD_P3)+",N)"
				ElseIf theSDInfoLst(SI)(SD_TYPE) = "R" Then
					Build = Build+"CalcRatAB("+theSDInfoLst(SI)(SD_P1)+","+theSDInfoLst(SI)(SD_P2)+","+theSDInfoLst(SI)(SD_P3)+",N)"
				ElseIf theSDInfoLst(SI)(SD_TYPE) = "T" Then
					Build = Build+"LinFmod("+theSDInfoLst(SI)(SD_P1)+","+theSDInfoLst(SI)(SD_P2)+","+theSDInfoLst(SI)(SD_P3)+","+theSDInfoLst(SI)(SD_P4)+","+theSDInfoLst(SI)(SD_P5)+",L"
					If theSDInfoLst(SI)(SD_P6) <> "" Then
						Build = Build+","+theSDInfoLst(SI)(SD_P6)+")*N"
					Else
						Build = Build+")*N"
					End If
				End If

				If theSDInfoLst(SI)(SD_DECIMALS) <> "" Then
					If theSDInfoLst(SI)(SD_DECIMALS) = "0" Then
						Build = "RoundDbl("+Build+")"
					Else
						Build = "RoundDbl("+Build+","+theSDInfoLst(SI)(SD_DECIMALS)+")"
					End If
				End If

				Build = Replace(Replace(Build,"!",""""),"|",",")

				Build = Replace(Build,"+-","-")

				Build = ReplStatRefs(Build)
				
.WriteText "				return "+Build+";", adWriteLine
			Next	

			If theSDInfoLst(StatPos)(SD_LSTART) <> "" Or theSDInfoLst(StatPos)(SD_LEND) <> "" Then
.WriteText "			end", adWriteLine
			End If

		End If

	End With

End Sub

Function ReplStatRefs(ByVal theBuild)

	Dim Result
	Result = theBuild

	Dim nSearch
	Dim BI
	Dim sStartToken, sNumToken, sEncapStartToken, sEncapEndToken
	Dim nEncapOpen
	Dim sStatName
	Dim cStatChar
	Dim sLevel
	Dim sNumber

	sStartToken = "@"
	sNumToken = "#"
	sEncapStartToken = "{"
	sEncapEndToken = "}"

	nSearch = InStr(Result,sStartToken)
	While nSearch > 0
		Result = Left(Result,nSearch-1)+Right(Result,Len(Result)-nSearch+1-Len(sStartToken))

		sStatName = ""
		For BI = nSearch To Len(Result)
			cStatChar = Mid(Result,BI,1)
			If ("A" <= UCase(cStatChar) And UCase(cStatChar) <= "Z") Or (("0" <= UCase(cStatChar) And UCase(cStatChar) <= "9") And ("A" <= UCase(Mid(Result,BI+1,1)) And UCase(Mid(Result,BI+1,1)) <= "Z"))Then
				sStatName = sStatName+cStatChar
			Else
				Exit For	
			End If
		Next

		If Len(sStatName) > 0 Then
			Result = Left(Result,nSearch-1)+"CalcStat("""+sStatName+""""+Right(Result,Len(Result)-nSearch+1-Len(sStatName))
			nSearch = nSearch+Len("CalcStat("""+sStatName+"""")

			sLevel = ""
			If Mid(Result,nSearch,Len(sEncapStartToken)) = sEncapStartToken Then
				Result = Left(Result,nSearch-1)+Right(Result,Len(Result)-nSearch+1-Len(sEncapStartToken))
				nEncapOpen = 1
				For BI = nSearch To Len(Result)
					cStatChar = Mid(Result,BI,1)
					If Mid(Result,BI,Len(sEncapStartToken)) = sEncapStartToken Then
						nEncapOpen = nEncapOpen+1
					End If
					If Mid(Result,BI,Len(sEncapEndToken)) = sEncapEndToken Then
						nEncapOpen = nEncapOpen-1
					End If
					If nEncapOpen > 0 Then
						sLevel = sLevel+cStatChar
					Else
						Result = Left(Result,BI-1)+Right(Result,Len(Result)-BI+1-Len(sEncapEndToken))
						Exit For
					End If
				Next
			ElseIf "0" <= Mid(Result,nSearch,1) And Mid(Result,nSearch,1) <= "9" Then
				For BI = nSearch To Len(Result)
					cStatChar = Mid(Result,BI,1)
					If "0" <= cStatChar And cStatChar <= "9" Then
						sLevel = sLevel+cStatChar
					Else
						Exit For
					End If
				Next
			End If
			If sLevel = "" Then
				Result = Left(Result,nSearch-1)+",L"+Right(Result,Len(Result)-nSearch+1)
				nSearch = nSearch+Len(",L")
			Else
				Result = Left(Result,nSearch-1)+","+sLevel+Right(Result,Len(Result)-nSearch+1-Len(sLevel))
				nSearch = nSearch+Len(","+sLevel)
			End If

			If Mid(Result,nSearch,Len(sNumToken)) = sNumToken Then
				Result = Left(Result,nSearch-1)+Right(Result,Len(Result)-nSearch+1-Len(sNumToken))

				sNumber = ""
				If Mid(Result,nSearch,Len(sEncapStartToken)) = sEncapStartToken Then
					Result = Left(Result,nSearch-1)+Right(Result,Len(Result)-nSearch+1-Len(sEncapStartToken))
					nEncapOpen = 1
					For BI = nSearch To Len(Result)
						cStatChar = Mid(Result,BI,1)
						If Mid(Result,BI,Len(sEncapStartToken)) = sEncapStartToken Then
							nEncapOpen = nEncapOpen+1
						End If
						If Mid(Result,BI,Len(sEncapEndToken)) = sEncapEndToken Then
							nEncapOpen = nEncapOpen-1
						End If
						If nEncapOpen > 0 Then
							sNumber = sNumber+cStatChar
						Else
							Result = Left(Result,BI-1)+Right(Result,Len(Result)-BI+1-Len(sEncapEndToken))
							rem MsgBox "["+Result+"]"
							Exit For
						End If
					Next
				ElseIf "0" <= Mid(Result,nSearch,1) And Mid(Result,nSearch,1) <= "9" Then
					For BI = nSearch To Len(Result)
						cStatChar = Mid(Result,BI,1)
						If ("0" <= cStatChar And cStatChar <= "9") Or cStatChar = "." Then
							sNumber = sNumber+cStatChar
						Else
							Exit For
						End If
					Next
				End If
				If sNumber = "" Then
					Result = Left(Result,nSearch-1)+",N)"+Right(Result,Len(Result)-nSearch+1)
					nSearch = nSearch+Len(",N)")
				Else
					Result = Left(Result,nSearch-1)+","+sNumber+")"+Right(Result,Len(Result)-nSearch+1-Len(sNumber))
					nSearch = nSearch+Len(","+sNumber+")")
				End If
			Else
				Result = Left(Result,nSearch-1)+")"+Right(Result,Len(Result)-nSearch+1)
				nSearch = nSearch+Len(")")
			End If

		End If

		nSearch = InStr(Result,sStartToken)
	Wend

	ReplStatRefs = Result

End Function

Sub WriteScrStats(theOutStream,theHSN,theSDInfoLst)

	Dim sStat, sLastStat
	sLastStat = ""

	With theOutStream
		For SI = LBound(theSDInfoLst) To UBound(theSDInfoLst)
			sStat = theSDInfoLst(SI)(SD_STAT)
			If Left(sStat,1) = theHSN And sStat <> sLastStat Then
				If sLastStat <> "" Then
.WriteText "		elseif sn == """+sStat+""" then", adWriteLine
				Else
.WriteText "		if sn == """+sStat+""" then", adWriteLine
				End If
				WriteScrStat theOutStream,sStat,theSDInfoLst
				sLastStat = sStat
			End If
		Next
.WriteText "		else", adWriteLine
.WriteText "				return 0;", adWriteLine
.WriteText "		end", adWriteLine
	End With

End Sub

Sub WriteScrHSNs(theOutStream,theSDInfoLst)

	Dim sHSN, sLastHSN
	sLastHSN = ""

	With theOutStream
		For SI = LBound(theSDInfoLst) To UBound(theSDInfoLst)
			sHSN = Left(theSDInfoLst(SI)(SD_STAT),1)
			If sHSN <> sLastHSN Then
				If sLastHSN <> "" Then
.WriteText "	elseif hsn == """+sHSN+""" then", adWriteLine
				Else
.WriteText "	if hsn == """+sHSN+""" then", adWriteLine
				End If
				WriteScrStats theOutStream,sHSN,theSDInfoLst
				sLastHSN = sHSN
			End If
		Next
.WriteText "	else", adWriteLine
.WriteText "				return 0;", adWriteLine
.WriteText "	end", adWriteLine
	End With

End Sub

Sub ReadSDFile(ByVal theInFile, ByRef theSDInfoLst)

	Dim InStream
	Set InStream = CreateObject("ADODB.Stream")
	With InStream
		.Type = adTypeText
		.CharSet = "UTF-8"
		.LineSeparator = adLF
		.Open
		.LoadFromFile theInFile

		Dim ReadError
		ReadError = False

		Dim RowText
		RowText = ""

		'skip header line
		RowText = .ReadText(adReadLine)

		Do Until .EOS OR ReadError
			RowText = .ReadText(adReadLine)

			RowText = Replace(RowText,Chr(10),"")
			RowText = Replace(RowText,Chr(13),"")

			Dim NewSDInfo
			InitSDInfo NewSDInfo

			For FldI = LBound(NewSDInfo) To UBound(NewSDInfo)
				ReadSDField RowText, NewSDInfo(FldI)
			Next

			If NewSDInfo(SD_STAT) = "" Then
				Break
			Else
				If IsEmpty(theSDInfoLst) Then
					ReDim theSDInfoLst(0)
				Else
					ReDim Preserve theSDInfoLst(UBound(theSDInfoLst)+1)
				End If
				theSDInfoLst(UBound(theSDInfoLst)) = NewSDInfo
			End If
		Loop

		.Close
	End With
	Set InStream = Nothing

End Sub

Sub InitSDInfo(ByRef theSDInfo)

	theSDInfo = Array("","","","","","","","","","","")
				
End Sub

Sub ReadSDField(ByRef RowText, ByRef NewSDFld)

	Dim SepPos
	SepPos = InStr(RowText,SDFLDSEP)
	If SepPos > 0 Then
		NewSDFld = RTrim(Mid(RowText,1,SepPos-1))
		RowText = LTrim(Mid(RowText,SepPos+1,Len(RowText)-SepPos))
	Else
		NewSDFld = Rtrim(RowText)
		RowText = ""
	End If

	If Len(NewSDFld) >= 2 Then
		If Mid(NewSDFld,1,1) = SDSTRQUOT AND Mid(NewSDFld,Len(NewSDFld),1) = SDSTRQUOT Then
			NewSDFld = Mid(NewSDFld,2,Len(NewSDFld)-2)
		End If
	End If

End Sub
